//տ GS ̴
#include "00_Global.fx"
#include "00_Light.fx"
#include "00_Render.fx"

//-----------------------------------------------------------------------------
// Mesh, Model, Animation 
//-----------------------------------------------------------------------------
float4 PS(MeshOutput input) : SV_Target
{
    return PS_AllLight(input);
};

//-----------------------------------------------------------------------------
// Geometry(GS) Billboard
//-----------------------------------------------------------------------------
//Input From IA (ö IA )
struct VertexInput_Billboard
{
    float4 Position : Position;
    float2 Scale : Scale;
    uint MapIndex : MapIndex; // ׸
};
//Output to GS ( GS ó)
struct VertexOutput_Billboard
{
    //RS ܰ谡 VS ƴϹǷ SV_Position Ŀ SV
    float4 Position : Position;
    float2 Scale : Scale;
    uint MapIndex : MapIndex;
};
    
//VS
VertexOutput_Billboard VS_Billboard(VertexInput_Billboard input)
{
    VertexOutput_Billboard output;
    
    //World(VS) View,Projction (GS) ó
    //World vs óϴ  vsܰ迡   ó ϱ ؼ
    //View,Projction gs óϴ  (ϴ) ̱ 
    output.Position = WorldPosition(input.Position);
    output.Scale = input.Scale;
    output.MapIndex = input.MapIndex;
    
    return output;
};

//GS (output) ->RS ѱ ü
struct GeometryOutput_Billboard
{
    float4 Position : SV_Position;
    float2 Uv : Uv;
    uint MapIndex : MapIndex;
};

//GS (point =   , triangle ﰢ )
//  1 ް,  (ﰢ) ؼ 
[maxvertexcount(4)] //ִ 4 
void GS_Billboard(point VertexOutput_Billboard input[1], inout TriangleStream<GeometryOutput_Billboard> stream)
{
    //ī޶  
    float3 up = float3(0, 1, 0);
    float3 forward = normalize(input[0].Position.xyz - ViewPosition()); //ī޶
    float3 right = normalize(cross(up, forward)); //, 
    
    float2 halfSize = input[0].Scale * 0.5f;
    
    // ߽  ġ ڵ
    float4 position[4];
    //input[0].Position.xyz - halfSize.x * right - halfSize.y * up ̰ float3   , 1 ġ
    position[0] = float4(input[0].Position.xyz - halfSize.x * right - halfSize.y * up, 1); // 
    position[1] = float4(input[0].Position.xyz - halfSize.x * right + halfSize.y * up, 1); // »
    position[2] = float4(input[0].Position.xyz + halfSize.x * right - halfSize.y * up, 1); // 
    position[3] = float4(input[0].Position.xyz + halfSize.x * right + halfSize.y * up, 1); // 

    float2 uv[4] = { 
        float2(0, 1), 
        float2(0, 0), 
        float2(1, 1),
        float2(1, 0)};
    
    GeometryOutput_Billboard output;
    
    [unroll(4)]
    for (int i = 0; i < 4; i++)
    {
        output.Position = ViewProjection(position[i]);
        output.Uv = uv[i];
        output.MapIndex = input[0].MapIndex;
        //
        //Append ()ϴµ ִ 4(maxvertexcount) 
        stream.Append(output);
    }
}

//GS 2
[maxvertexcount(8)]
void GS_Billboard_Cross(point VertexOutput_Billboard input[1], inout TriangleStream<GeometryOutput_Billboard> stream)
{
    float3 up = float3(0, 1, 0);
    float3 forward = float3(0, 0, 1);
    float3 right = normalize(cross(up, forward));

    float2 halfSize = input[0].Scale * 0.5f;
    
    float4 position[8];
    position[0] = float4(input[0].Position.xyz - halfSize.x * right - halfSize.y * up, 1); // 
    position[1] = float4(input[0].Position.xyz - halfSize.x * right + halfSize.y * up, 1); // »
    position[2] = float4(input[0].Position.xyz + halfSize.x * right - halfSize.y * up, 1); // 
    position[3] = float4(input[0].Position.xyz + halfSize.x * right + halfSize.y * up, 1); // 
    
    position[4] = float4(input[0].Position.xyz - halfSize.x * forward - halfSize.y * up, 1); // 
    position[5] = float4(input[0].Position.xyz - halfSize.x * forward + halfSize.y * up, 1); // »
    position[6] = float4(input[0].Position.xyz + halfSize.x * forward - halfSize.y * up, 1); // 
    position[7] = float4(input[0].Position.xyz + halfSize.x * forward + halfSize.y * up, 1); // 
    
    float2 uv[4] =
    {
        float2(0, 1),
        float2(0, 0),
        float2(1, 1),
        float2(1, 0)
    };
    
    GeometryOutput_Billboard output;
    
    [unroll(8)]
    for (int i = 0; i < 8; i++)
    {
        output.Position = ViewProjection(position[i]);
        output.Uv = uv[i % 4];
        output.MapIndex = input[0].MapIndex;
        
        if (i % 4 == 0) 
            stream.RestartStrip(); //  ڸ
            
        stream.Append(output);
    }
}

Texture2DArray BillboardMaps; // ÿ
float4 PS_Billboard(GeometryOutput_Billboard input) : SV_Target
{
    //return DiffuseMap.Sample(PointSampler, input.Uv);
    //float3 ǹ (uv , ° )
    return BillboardMaps.Sample(PointSampler, float3(input.Uv, input.MapIndex));
};

technique11 T0
{
    P_VP(P0, VS_Mesh, PS)
    P_VP(P1, VS_Model, PS)
    P_VP(P2, VS_Animation, PS)

    //GS ҷ ߰ Gٿ 
    P_BS_VGP(P3, AlphaBlend, VS_Billboard, GS_Billboard, PS_Billboard)
    P_BS_VGP(P4, AlphaBlend_AlphaToCoverageEnable, VS_Billboard, GS_Billboard, PS_Billboard)

    //׸ ޸ Ⱥ
    P_BS_VGP(P5, AlphaBlend, VS_Billboard, GS_Billboard_Cross, PS_Billboard)
    P_BS_VGP(P6, AlphaBlend_AlphaToCoverageEnable, VS_Billboard, GS_Billboard_Cross, PS_Billboard)

    //  ذ
    P_RS_BS_VGP(P7, CullMode_None, AlphaBlend, VS_Billboard, GS_Billboard_Cross, PS_Billboard)
    P_RS_BS_VGP(P8, CullMode_None, AlphaBlend_AlphaToCoverageEnable, VS_Billboard, GS_Billboard_Cross, PS_Billboard)
    
    //   ذ
    P_RS_DSS_BS_VGP(P9, CullMode_None, PixleDepthEnable_False, AlphaBlend_AlphaToCoverageEnable, VS_Billboard, GS_Billboard_Cross, PS_Billboard)
};